package it.polito.bigdata.hadoop.exercise1;

import java.io.IOException;

import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

/**
 * Exercise 1 - Reducer
 */
class ReducerBigData extends Reducer<Text, // Input key type
		Text, // Input value type
		Text, // Output key type
		Text> { // Output value type

	protected void reduce(Text key, // Input key type
			Iterable<Text> values, // Input value type
			Context context) throws IOException, InterruptedException {

		// Iterate over the set of values
		// Check if there is only one model type
		// Since the MID is the identifier of the model, every MID occurs at most one time in 
		// input file. This means that each MID occurs at most one time also in values.
		// This means that the brands we are interested in are those with one single element in values 
		String mid = null;
		Integer numElements=0;

		for (Text value : values) {
			mid = value.toString();
			numElements++;
		}

		// Emit brand,mid if the brand is associated to one single model
		if (numElements == 1)
			context.write(new Text(key), new Text(mid));
	}
}
